(in-package #:simpsamp)

(defun list-sample-of-list (n list)
  (declare (type jpl-util:array-dimension n)
	   (type list list)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-list (x n list)
      (accumulate x))))

(defun list-sample-of-vector (n vector)
  (declare (type jpl-util:array-dimension n)
	   (type vector vector)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-vector (x n vector)
      (accumulate x))))

(defun list-sample-of-hash-table-keys (n hash-table)
  (declare (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-hash-table (key value n hash-table)
      (accumulate key))))

(defun list-sample-of-hash-table-values (n hash-table)
  (declare (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-hash-table (key value n hash-table)
      (accumulate value))))

(defun list-sample-of-hash-table-pairs (n hash-table)
  (declare (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-hash-table (key value n hash-table)
      (accumulate (cons key value)))))

(defun list-sample-of-range (n lower upper)
  (declare (type jpl-util:array-dimension n)
	   (type integer lower upper)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-range (x n lower upper)
      (accumulate x))))

(defun list-sample-of-iterator (n size next-fn)
  (declare (type jpl-util:array-dimension n)
	   (type (integer 0) size)
	   (type jpl-util:function-designator next-fn)
	   (optimize speed))
  (jpl-util:accumulate-to-list (accumulate)
    (do-sample-of-iterator ((x) n size next-fn)
      (accumulate x))))

(defun list-sample-of-unbounded-iterator (n next-fn exhausted?-fn)
  (declare (type jpl-util:array-dimension n)
	   (type jpl-util:function-designator next-fn exhausted?-fn)
	   (optimize speed))
  (coerce (vector-sample-of-unbounded-iterator n next-fn exhausted?-fn) 'list))
