(in-package #:simpsamp)

(defun map-sample-of-list (function n list)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type list list)
	   (optimize speed))
  (do-sample-of-list (x n list)
    (funcall function x)))

(defun map-sample-of-vector (function n vector)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type vector vector)
	   (optimize speed))
  (do-sample-of-vector (x n vector)
    (funcall function x)))

(defun map-sample-of-hash-table-keys (function n hash-table)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (do-sample-of-hash-table (key value n hash-table)
    (funcall function key)))

(defun map-sample-of-hash-table-values (function n hash-table)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (do-sample-of-hash-table (key value n hash-table)
    (funcall function value)))

(defun map-sample-of-hash-table (function n hash-table)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type hash-table hash-table)
	   (optimize speed))
  (do-sample-of-hash-table (key value n hash-table)
    (funcall function key value)))

(defun map-sample-of-range (function n lower upper)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type integer lower upper)
	   (optimize speed))
  (do-sample-of-range (x n lower upper)
    (funcall function x)))

(defun map-sample-of-iterator (function n size next-fn)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type (integer 0) size)
	   (type jpl-util:function-designator next-fn)
	   (optimize speed))
  (do-sample-of-iterator (values n size next-fn)
    (apply function values)))

(defun map-sample-of-unbounded-iterator (function n next-fn exhausted?-fn)
  (declare (type jpl-util:function-designator function)
	   (type jpl-util:array-dimension n)
	   (type jpl-util:function-designator next-fn exhausted?-fn)
	   (optimize speed))
  (do-sample-of-unbounded-iterator (x n next-fn exhausted?-fn)
    (funcall function x)))
